#include <stdio.h>
#include <mpi.h>
#define A(I,J) p[(I)+((J)-(*jf-1))*(*m+2)]

void exchange_ghostline4__(double *p,int *m,int *jf,int *jl,
			  int *my_rank,int *nproc,
			  MPI_Comm *mpi_comm,MPI_Datatype *irealtype){
  int itag=10;
  MPI_Status istat;
  int nline;
  
  nline=*m+2;

  
/************************************
*   0    1    2    3    4 
*    -><-      -><- 
*************************************/{
    if(*my_rank<*nproc-1 && *my_rank%2==0)
      MPI_Sendrecv((void *)&A(0,*jl)  ,nline,*irealtype,*my_rank+1,itag, 
		   (void *)&A(0,*jl+1),nline,*irealtype,*my_rank+1,itag,
		   *mpi_comm,&istat);
    if(/* 0<*my_rank  && */ *my_rank%2==1)
      MPI_Sendrecv((void *)&A(0,*jf)  ,nline,*irealtype,*my_rank-1,itag, 
		   (void *)&A(0,*jf-1),nline,*irealtype,*my_rank-1,itag,
		   *mpi_comm,&istat);
  }

  
/************************************
*   0    1    2    3    4 
*         -><-      -><-
*************************************/{
    if(0<*my_rank        && *my_rank%2==0)
      MPI_Sendrecv((void *)&A(0,*jf)  ,nline,*irealtype,*my_rank-1,itag, 
		   (void *)&A(0,*jf-1),nline,*irealtype,*my_rank-1,itag,
		   *mpi_comm,&istat);
    if(*my_rank<*nproc-1 && *my_rank%2==1)
      MPI_Sendrecv((void *)&A(0,*jl)  ,nline,*irealtype,*my_rank+1,itag, 
		   (void *)&A(0,*jl+1),nline,*irealtype,*my_rank+1,itag,
		   *mpi_comm,&istat);
  }
}
