

      subroutine exchange_ghostline1(a,m,jf,jl,my_rank,nproc,mpi_comm,
     $     irealtype)
      implicit real*8(a-h,o-z)
      include "mpif.h"
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     

c     
c     
      integer istat(MPI_STATUS_SIZE)
c     
c     
      dimension a(0:m+1,jf-1:jl+1)
c
c     
      parameter(itag=10)
c-----|---------------------------------------------------------------|



      nline=m+2
      if (my_rank.gt.0) then



         CALL MPI_SENDRECV(
     $        a(0,jf)  ,nline,irealtype,my_rank-1,itag, 
     $        a(0,jf-1),nline,irealtype,my_rank-1,itag,
     $        mpi_comm,istat,ierr)



      endif
      if (my_rank.lt.nproc-1) then



         CALL MPI_SENDRECV(
     $        a(0,jl)  ,nline,irealtype,my_rank+1,itag, 
     $        a(0,jl+1),nline,irealtype,my_rank+1,itag,
     $        mpi_comm,istat,ierr)



      endif      
c     
      return
      end
c-----|---------------------------------------------------------------|
      subroutine exchange_ghostline2(a,m,jf,jl,my_rank,nproc,mpi_comm,
     $     irealtype)
      implicit real*8(a-h,o-z)
      include "mpif.h"
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
      parameter(nmsg=2)
      integer istat(MPI_STATUS_SIZE,2*nmsg),ireq(2*nmsg)
      integer iseq_send(nmsg),iseq_recv(nmsg)
      data iseq_send /-1,+1/ !order of the send operations
      data iseq_recv /+1,-1/ !order of the recv operations
c     
c     
      dimension a(0:m+1,jf-1:jl+1)
c
c     
      parameter(itag=10)
c-----|---------------------------------------------------------------|
      nline=m+2
      nreq=0
c     
      do ii=1,nmsg
c     
c     
c     
         idest=my_rank+iseq_send(ii)
         if (idest.ge.0.and.idest.le.nproc-1) then
            if(iseq_send(ii).eq.+1)then
               jj=jl
            else
               jj=jf
            endif
            nreq=nreq+1



            call MPI_ISEND(a(0,jj),nline,irealtype,
     $           idest,itag,mpi_comm,ireq(nreq),ierr)



         end if
c     
c     
c     
         iorig=my_rank+iseq_recv(ii)
         if (iorig.ge.0.and.iorig.le.nproc-1) then
            if(iseq_recv(ii).eq.+1)then
               jj=jl+1
            else
               jj=jf-1
            endif
            nreq=nreq+1



            call MPI_IRECV(a(0,jj),nline,irealtype,
     $           iorig,itag,mpi_comm,ireq(nreq),ierr)



         end if
c     
      enddo
c     
c     
c     



      call MPI_WAITALL(nreq,ireq,istat,ierr)



c     
      return
      end
c-----|---------------------------------------------------------------|
      subroutine exchange_ghostline3(a,m,jf,jl,my_rank,nproc,mpi_comm,
     $     irealtype)
      implicit real*8(a-h,o-z)
      include "mpif.h"
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     
c     

c     
c     
      integer istat(MPI_STATUS_SIZE)
c     
c     
      dimension a(0:m+1,jf-1:jl+1)
c
c     
      parameter(itag=10)
c-----|---------------------------------------------------------------|
      nline=m+2
 1    format('I am ',i3,',   communicating with',i3)
c     
      if (my_rank.lt.nproc-1) then
         if(mod(my_rank,2).eq.0) then



            CALL MPI_SENDRECV(
     $           a(0,jl)  ,nline,irealtype,my_rank+1,itag, 
     $           a(0,jl+1),nline,irealtype,my_rank+1,itag,
     $           mpi_comm,istat,ierr)
         endif      
         if(mod(my_rank,2).eq.1) then



            CALL MPI_SENDRECV(
     $           a(0,jf)  ,nline,irealtype,my_rank-1,itag, 
     $           a(0,jf-1),nline,irealtype,my_rank-1,itag,
     $           mpi_comm,istat,ierr)
         endif
      endif
      




c      
      if (my_rank.gt.0) then
         if(mod(my_rank,2).eq.0) then



            CALL MPI_SENDRECV(
     $           a(0,jf)  ,nline,irealtype,my_rank-1,itag, 
     $           a(0,jf-1),nline,irealtype,my_rank-1,itag,
     $           mpi_comm,istat,ierr)
         endif
         if(mod(my_rank,2).eq.1) then



            CALL MPI_SENDRECV(
     $           a(0,jl)  ,nline,irealtype,my_rank+1,itag, 
     $           a(0,jl+1),nline,irealtype,my_rank+1,itag,
     $           mpi_comm,istat,ierr)
         endif      
      endif
c
      return
      end
c-----|---------------------------------------------------------------|
