linewidth=2;
symbolsize=8;
fontsize=16;
set(0,'DefaultAxesFontName','Helvetica','DefaultAxesFontSize',fontsize);
%%-----------------------------------------------------------------%
dat1=load('timing_turanga1.tmp');
dat2=load('timing_turanga2.tmp');
%dat4=load('timing_turanga4.tmp');
icolp=3;
icolt=4;
npmax=8;
%---------------------------------------------------------------------
f=figure;a=axes;hold on;
plot(dat1(:,icolp),dat1(1,icolt)./dat1(:,icolt),'ko-');
plot(dat2(:,icolp),dat2(1,icolt)./dat2(:,icolt),'ro-');
%plot(dat4(:,icolp),dat4(1,icolt)./dat4(:,icolt),'bo-');
plot([1 npmax],[1 npmax],'k--');
%title('jacobi iteration of poisson problem with m=n=250 f-d nodes');
%xlabel('no. of procs');ylabel('speed-up');
set(a,'DataAspectRatio',[1 1 1]);
set(a,'XLim',[1 npmax],'YLim',[1 npmax]);
set(a,'XTick',[(0:npmax)]);
set(a,'YTick',[(0:npmax)]);
legend('comm. pattern 1','comm. pattern 2',0);
%legend('comm. pattern 1','comm. pattern 2','comm. pattern 4',0);
%
%print -depsc speed_jacobi_turanga.eps